unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,  StdCtrls, ControlCAN;

type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Button5: TButton;
    GroupBox2: TGroupBox;
    Label8: TLabel;
    Label9: TLabel;
    Button6: TButton;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    Edit1: TEdit;
    Edit4: TEdit;
    GroupBox6: TGroupBox;
    ListBox1: TListBox;
    GroupBox3: TGroupBox;
    Label13: TLabel;
    EditCfgPath: TEdit;
    ButtonBroswerCfgFile: TButton;
    Label1: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button6Click(Sender: TObject);

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonBroswerCfgFileClick(Sender: TObject);
    function LoadConfig(const strCfgPath: string) : string;

  private
    { Private declarations }
  public

  end;
  
PTListBox=^TListBox;
var
  Form1: TForm1;
var
    m_devtype : DWORD;
    m_devind : DWORD;
    m_cannum : DWORD;
    m_connect : DWORD;
    m_threadhandle : integer;
    m_sendTimeout: DWORD  ;
    m_strCfgFilePath: string;
    const GCanBrTab:array[0..9] of DWORD = (1000000, 800000, 500000,250000, 125000, 100000,50000, 20000, 10000,5000);




implementation

{$R *.dfm}
function ReceiveThread(param : Pointer): integer;
var
receivedata : array[0..500] of VCI_CAN_OBJ;
len : integer;
j : integer;
i : integer;
length : integer;
str : AnsiString;
tmpstr :AnsiString;
box : PTListBox;
errinfo : VCI_ERR_INFO;
begin
  box:=param;
   while TRUE do
    begin
      if m_connect=0 then
        break;
      Sleep(1);
      length := VCI_GetReceiveNum(m_devtype,m_devind,m_cannum);
      if length <= 0 then
      begin
         continue;
      end;
      len:=VCI_Receive(m_devtype,m_devind,m_cannum,@receivedata[0],length,200);
      if len<=0 then
        begin
          //ע⣺ûжô˺ȡǰĴ룬
    			//ǧʡһʹ֪ܲʲô
		    	VCI_ReadErrInfo(m_devtype,m_devind,m_cannum,@errinfo);
          continue;
        end;
      for i:=0 to len-1 do
        begin
	    		str:='յ֡:  ';
    			if receivedata[i].TimeFlag=0 then
		  		  tmpstr:='ʱʶ:  '
    			else
    				tmpstr:='ʱʶ:0x'+IntToHex(receivedata[i].TimeStamp,8)+' ';
			    str:=str+tmpstr;
			    tmpstr:='֡ID:0x'+IntToHex(receivedata[i].ID,8)+' ';
			    str:=str+tmpstr;
			    str:=str+'֡ʽ:';
			    if receivedata[i].RemoteFlag=0 then
				    tmpstr:='֡ '
			    else
				    tmpstr:='Զ֡ ';
    			str:=str+tmpstr;
		      str:=str+'֡:';
			    if receivedata[i].ExternFlag=0 then
    				tmpstr:='׼֡ '
    			else
		    		tmpstr:='չ֡ ';
    			str:=str+tmpstr;
    			box.Items.Add(str);
	    		if receivedata[i].RemoteFlag=0 then
          begin
    				str:=':';
            if receivedata[i].DataLen>8 then
              receivedata[i].DataLen:=8;
    				for j:=0 to receivedata[i].DataLen-1 do
              begin
      					tmpstr:=IntToHex(receivedata[i].Data[j],2)+' ';
	      				str:=str+tmpstr;
              end;
   				box.Items.Add(str);
          end;
        end;
	  	box.ItemIndex:=box.Items.Count-1;
    end;

  EndThread(0);
  ReceiveThread:=0;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
devtype:integer;
index: integer;
cannum: integer;
threadid: LongWord;
sysTime:SYSTEMTIME;
strCfgText: string;
dtuConfig: DTUCOMCONFIG;
pCfgBuffer: PCHAR;

begin
devtype:=CANDTU_DEV_TYPE;
index:=ComboBox1.ItemIndex;
cannum:=ComboBox2.ItemIndex;
m_devtype:=devtype;

if m_connect=1 then
  begin
    m_connect:=0;
    Button1.Caption:='';
    VCI_CloseDevice(m_devtype,m_devind);

    Exit;
  end;
if (index>=0) and (cannum>=0)  then
  begin
    if VCI_OpenDevice(m_devtype,index,0)<>1 then
      ShowMessage('˿ڴʧ')
    else
      begin
         if VCI_InitCAN(m_devtype,index,cannum,nil)<>1 then
          begin
            Showmessage('ʼCANʧ');
            VCI_CloseDevice(m_devtype,index);
            Exit;
          end;

        //ֻʾ豸ʱ÷ϢûдĿԲ
        GetLocalTime(sysTime);
        if VCI_SetReference(m_devtype, index, cannum, REFERENCE_TYPE_RTC, @sysTime) <> 1 then
          begin
            Showmessage('ϵͳʱʧ');
            VCI_CloseDevice(m_devtype,index);
            Exit;
          end;

        if not FileExists(m_strCfgFilePath) then
         begin
           Showmessage('ļ·ָ');
           VCI_CloseDevice(m_devtype,index);
           Exit;
         end;
        strCfgText := LoadConfig(m_strCfgFilePath);
        dtuConfig.dwLen := Length(strCfgText);
        pCfgBuffer := strAlloc(dtuConfig.dwLen);
        dtuConfig.pData := pCfgBuffer;
        StrPLCopy(pCfgBuffer, strCfgText, dtuConfig.dwLen);
        if VCI_SetReference(m_devtype, index, cannum, REFERENCE_TYPE_DEVICE_CFG, @dtuConfig) <> 1 then
          begin
            Showmessage('豸ʧ');
            VCI_CloseDevice(m_devtype,index);
            strDispose(pCfgBuffer);
            Exit;
          end;

        strDispose(pCfgBuffer);

        m_devind:=index;
        m_cannum:=cannum;
        m_connect:=1;
        Button1.Caption:='Ͽ';
        threadid:=111;
        m_threadhandle:=BeginThread(nil,0,ReceiveThread,@ListBox1,0,threadid);
      end;
  end
else
  ShowMessage('ѡΪ');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if m_connect=0 then
    Exit;
  if VCI_ResetCAN(m_devtype,m_devind,m_cannum)<>1 then
    ShowMessage('λCANʧ')
  else
    ListBox1.Items.Add('λCANɹ');

end;

procedure TForm1.FormCreate(Sender: TObject);
var
  strConfig : string;
begin
  m_devtype := CANDTU_DEV_TYPE;//USB-CANDTUͺ
  m_devind := 0;
  m_cannum :=0;
  m_connect:= 0;
  ComboBox1.ItemIndex:=0;
  ComboBox2.ItemIndex:=0;
  ComboBox5.ItemIndex:=0;
  ComboBox6.ItemIndex:=0;
  ComboBox7.ItemIndex:=0;

  strConfig := ExtractFilePath(Application.ExeName);
  strConfig := strConfig + 'config_250k.ini';
  m_strCfgFilePath := strConfig;
  EditCfgPath.Text := strConfig;


end;

procedure TForm1.Button5Click(Sender: TObject);
var
sendtype,frametype,frameformat : BYTE;
id : DWORD;
data : array[0..7] of BYTE;
str : AnsiString;
strdata : AnsiString;
senddata : VCI_CAN_OBJ;
i : integer;
begin
  if m_connect=0 then
    Exit;
  sendtype:=ComboBox5.ItemIndex;
  frametype:=ComboBox6.ItemIndex;
  frameformat:=ComboBox7.ItemIndex;
  id:=StrToInt('0x'+Edit1.Text);
  str:=Edit4.Text;
  for i:=0 to 7 do
    begin
      strdata:=Copy(str,3*i+1,2);
      strdata:=Trim(strdata);
      if Length(strdata)=0 then
        break;
      data[i]:=StrToInt('0x'+strdata);
    end;
  senddata.SendType:=sendtype;
  senddata.ExternFlag:=frametype;
  senddata.RemoteFlag:=frameformat;
  senddata.ID:=id;
  senddata.DataLen:=i;
  Move(data,senddata.Data,i);
  if VCI_Transmit(m_devtype,m_devind,m_cannum,@senddata,1)=1 then
    ListBox1.Items.Add('ͳɹ')
  else
    ListBox1.Items.Add('ʧ');
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if m_connect=0 then
    Exit;
  if VCI_StartCAN(m_devtype,m_devind,m_cannum)<>1 then
    ShowMessage('CANʧ')
  else
    ListBox1.Items.Add('CANɹ');

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if m_connect=1 then
  begin
    m_connect:=0;
    WaitForSingleObject(m_threadhandle,2000);
    m_threadhandle:=0;
    VCI_CloseDevice(m_devtype,m_devind);
  end
end;


procedure TForm1.ButtonBroswerCfgFileClick(Sender: TObject);
var
  dlgOpenCfg : TOpenDialog;
begin
  dlgOpenCfg := TOpenDialog.Create(self);
  dlgOpenCfg.Filter := '*.ini|*.ini';
  if dlgOpenCfg.Execute then
    begin
      m_strCfgFilePath := dlgOpenCfg.FileName;
      EditCfgPath.Text := m_strCfgFilePath;
    end;
end;

function TForm1.LoadConfig(const strCfgPath: string) : string;
var
  stringList: TStringList;
begin
  stringList := TStringList.Create;
  try
    stringList.LoadFromFile(strCfgPath);
    Result := stringList.GetText;
  finally
    stringList.Free;
end;

end;

end.


