/// @file
///    CANDTUExport.h
///
/// @brief
///    CANDTUο䶨ļ
///
/// @copyright
///    Guangzhou Zhiyuan Electronic Ltd.
///
/// @author
///    zl
///
/// @date
///    2015/10/16
///


#ifndef __CANDTU_EXPORT_H
#define __CANDTU_EXPORT_H

#include "ControlCAN.h"

#define CANDTU_FILTER_ITEM_COUNT       (8)

#define REFERENCE_TYPE_RTC             (1)
#define REFERENCE_TYPE_REALTIMEVIEW    (2)
#define REFERENCE_TYPE_DEVICE_CFG      (3)
#define REFERENCE_TYPE_DEVICE_CFG_SIZE (4)
#define REFERENCE_TYPE_DEV_STATE       (5)
#define REFERENCE_TYPE_CLEAR_DEV_STORAGE (6)

//ͨSet/GetReferenceãȡ豸ʱݲṹ
typedef struct _DTUCOMCONFIG
{
    DWORD   dwLen;
    BYTE*   pData;
} DTUCOMCONFIG;

///
/// @brief
///    豸״̬Ϣ
///
typedef struct {
    BYTE nRecording;      //豸Ƿڼ¼0δ¼1ڼ¼
    BYTE nSDState;        //SDǷ0SD쳣1SD
    BYTE nDataCleanState; //״̬01
    BYTE nReserved;       //
} CANDTUDEVSTATE;

#endif //__CANDTU_EXPORT_H
